#ifndef _RESUMESOCKET_H
#define _RESUMESOCKET_H

#include <TcpSocket.h>
#include <ISocketHandler.h>


class ResumeSocket : public TcpSocket
{
public:
	ResumeSocket(ISocketHandler&);
	~ResumeSocket();

	/** When a connect is made, we set the m_b_connected flag */
	void OnConnect();
	/** When the connection attempt fails, we try to reconnect with a new socket instance. 
	    This instance will be deleted, so remember to copy member variables. */
	void OnConnectFailed();
	/** If we are connected (m_b_connected is true), we Reconnect again. */
	void OnDelete();

private:
	ResumeSocket(const ResumeSocket& s) : TcpSocket(s) {} // copy constructor
	ResumeSocket& operator=(const ResumeSocket& ) { return *this; } // assignment operator
	/** Create a new instance and reconnect */
	ResumeSocket *Reconnect();
	bool m_b_connected;
};




#endif // _RESUMESOCKET_H
